(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/common'), require('primeng/inputtext'), require('primeng/dropdown'), require('primeng/checkbox'), require('primeng/radiobutton'), require('primeng/inputtextarea'), require('primeng/autocomplete'), require('primeng/calendar'), require('@angular/platform-browser/animations')) :
	typeof define === 'function' && define.amd ? define('blender-ui', ['exports', '@angular/core', '@angular/forms', '@angular/common', 'primeng/inputtext', 'primeng/dropdown', 'primeng/checkbox', 'primeng/radiobutton', 'primeng/inputtextarea', 'primeng/autocomplete', 'primeng/calendar', '@angular/platform-browser/animations'], factory) :
	(factory((global['blender-ui'] = {}),global.ng.core,global.ng.forms,global.ng.common,global.inputtext,global.dropdown,global.checkbox,global.radiobutton,global.inputtextarea,global.autocomplete,global.calendar,global.ng.platformBrowser.animations));
}(this, (function (exports,core,forms,common,inputtext,dropdown,checkbox,radiobutton,inputtextarea,autocomplete,calendar,animations) { 'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */










function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}
function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

var EXPANDED_INPUT_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return InputComponent; }),
    multi: true,
};
var InputComponent = /** @class */ (function () {
    function InputComponent() {
        this.isDisabled = false;
    }
    InputComponent.prototype.writeValue = function (obj) {
        this.value = (obj);
    };
    InputComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    InputComponent.prototype.registerOnTouched = function (fn) {
        this.onBlur = fn;
    };
    InputComponent.prototype.setDisabledState = function (isDisabled) {
        this.isDisabled = isDisabled;
    };
    InputComponent.prototype.ngOnInit = function () {
    };
    InputComponent.prototype.change = function ($event) {
        this.onChange(this.value);
    };
    return InputComponent;
}());
InputComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'b-input',
                template: "<div class=\"form-group\">\n    <label>{{config?.label}}</label>\n    <input type=\"text\" class=\"form-control\" pInputText [(ngModel)]=\"value\" [disabled]=\"isDisabled\" (blur)=\"onBlur()\" (change)=\"change($event)\"\n    />\n</div>",
                styles: [""],
                providers: [EXPANDED_INPUT_VALUE_ACCESSOR],
            },] },
];
InputComponent.ctorParameters = function () { return []; };
InputComponent.propDecorators = {
    "config": [{ type: core.Input },],
};
var EXPANDED_INPUT_VALUE_ACCESSOR$1 = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return DropdownComponent; }),
    multi: true,
};
var DropdownComponent = /** @class */ (function () {
    function DropdownComponent() {
        this.isDisabled = false;
    }
    DropdownComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    DropdownComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    DropdownComponent.prototype.registerOnTouched = function (fn) {
        this.onBlur = fn;
    };
    DropdownComponent.prototype.setDisabledState = function (isDisabled) {
        this.isDisabled = isDisabled;
    };
    DropdownComponent.prototype.ngOnInit = function () {
    };
    DropdownComponent.prototype.change = function ($event) {
        this.onChange(this.value);
    };
    return DropdownComponent;
}());
DropdownComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'b-dropdown',
                template: "<div class=\"form-group\">\n  <label>{{config?.label}}</label>\n  <p-dropdown [ngClass]=\"'form-control'\" [options]=\"config.options\" [(ngModel)]=\"value\" (onBlur)=\"onBlur()\" (onChange)=\"change($event)\"\n    [filter]=\"config.allowFilter\" filterBy=\"label\">\n  </p-dropdown>\n</div>",
                styles: [""],
                providers: [EXPANDED_INPUT_VALUE_ACCESSOR$1],
            },] },
];
DropdownComponent.ctorParameters = function () { return []; };
DropdownComponent.propDecorators = {
    "config": [{ type: core.Input },],
};
var EXPANDED_INPUT_VALUE_ACCESSOR$2 = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return CheckboxComponent; }),
    multi: true,
};
var CheckboxComponent = /** @class */ (function () {
    function CheckboxComponent() {
        this.selectedItems = [];
        this.isDisabled = false;
    }
    CheckboxComponent.prototype.writeValue = function (obj) {
        if (!!obj) {
            this.selectedItems = __spread(obj);
        }
    };
    CheckboxComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    CheckboxComponent.prototype.registerOnTouched = function (fn) {
        this.onBlur = fn;
    };
    CheckboxComponent.prototype.setDisabledState = function (isDisabled) {
        this.isDisabled = isDisabled;
    };
    CheckboxComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (!(this.config && this.config.options && this.config.options.length)) {
            this.config = Object.assign({ options: [] }, this.config);
        }
        this.config.options = this.config.options.map(function (i) { return ({
            name: _this.formatControlName(i.label),
            option: i
        }); });
    };
    CheckboxComponent.prototype.formatControlName = function (str) {
        return 'fc_' + str;
    };
    CheckboxComponent.prototype.change = function ($event) {
        this.onChange(this.selectedItems);
    };
    return CheckboxComponent;
}());
CheckboxComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'b-checkbox',
                template: "  <h6>{{config.label}}</h6>\n  <ng-template ngFor let-item [ngForOf]=\"config.options\" let-index>\n    <div class=\"form-check\" [ngClass]=\"{'form-check-inline':true}\">\n      <label class=\"form-check-label\">\n        <p-checkbox name=\"{{item.fcName}}\" value=\"{{item.option.value}}\" label=\"{{item.option.label}}\" [(ngModel)]=\"selectedItems\" (onChange)=\"change($event)\"></p-checkbox>\n      </label>\n    </div>\n  </ng-template>",
                styles: [""],
                providers: [EXPANDED_INPUT_VALUE_ACCESSOR$2],
            },] },
];
CheckboxComponent.ctorParameters = function () { return []; };
CheckboxComponent.propDecorators = {
    "config": [{ type: core.Input },],
};
var EXPANDED_INPUT_VALUE_ACCESSOR$3 = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return RadiobuttonComponent; }),
    multi: true,
};
var RadiobuttonComponent = /** @class */ (function () {
    function RadiobuttonComponent() {
        this.isDisabled = false;
    }
    RadiobuttonComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    RadiobuttonComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    RadiobuttonComponent.prototype.registerOnTouched = function (fn) {
        this.onBlur = fn;
    };
    RadiobuttonComponent.prototype.setDisabledState = function (isDisabled) {
        this.isDisabled = isDisabled;
    };
    RadiobuttonComponent.prototype.ngOnInit = function () {
        if (!(this.config && this.config.options && this.config.options.length)) {
            this.config = Object.assign({ options: [] }, this.config);
        }
    };
    RadiobuttonComponent.prototype.change = function (selectedItem) {
        this.onChange(selectedItem);
    };
    return RadiobuttonComponent;
}());
RadiobuttonComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'b-radiobutton',
                template: "<h6>{{config.label}}</h6>\n<ng-template ngFor let-item [ngForOf]=\"config.options\" let-index>\n  <div class=\"form-check\" [ngClass]=\"{'form-check-inline':true}\">\n    <label class=\"form-check-label\">\n        <p-radioButton [disabled]=\"isDisabled\" name=\"{{config.label}}\" label=\"{{item.label}}\" \n        value=\"{{item.value}}\" [(ngModel)]=\"value\" (onClick)=\"change(item.value)\" ></p-radioButton>\n    </label>\n  </div>\n</ng-template>",
                styles: [""],
                providers: [EXPANDED_INPUT_VALUE_ACCESSOR$3],
            },] },
];
RadiobuttonComponent.ctorParameters = function () { return []; };
RadiobuttonComponent.propDecorators = {
    "config": [{ type: core.Input },],
};
var EXPANDED_INPUT_VALUE_ACCESSOR$4 = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return TextareaComponent; }),
    multi: true,
};
var TextareaComponent = /** @class */ (function () {
    function TextareaComponent() {
        this.isDisabled = false;
    }
    TextareaComponent.prototype.writeValue = function (obj) {
        this.value = (obj);
    };
    TextareaComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    TextareaComponent.prototype.registerOnTouched = function (fn) {
        this.onBlur = fn;
    };
    TextareaComponent.prototype.setDisabledState = function (isDisabled) {
        this.isDisabled = isDisabled;
    };
    TextareaComponent.prototype.ngOnInit = function () {
    };
    TextareaComponent.prototype.change = function ($event) {
        this.onChange(this.value);
    };
    return TextareaComponent;
}());
TextareaComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'b-textarea',
                template: "<div class=\"form-group\">\n    <label>{{config?.label}}</label>\n    <textarea [rows]=\"5\" [cols]=\"30\" [(ngModel)]=\"value\" (change)=\"change($event)\" pInputTextarea autoResize=\"true\" [disabled]=\"isDisabled\"></textarea>\n</div>",
                styles: [""],
                providers: [EXPANDED_INPUT_VALUE_ACCESSOR$4],
            },] },
];
TextareaComponent.ctorParameters = function () { return []; };
TextareaComponent.propDecorators = {
    "config": [{ type: core.Input },],
};
var EXPANDED_INPUT_VALUE_ACCESSOR$5 = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return AutocompleteComponent; }),
    multi: true,
};
var AutocompleteComponent = /** @class */ (function () {
    function AutocompleteComponent() {
        this.isDisabled = false;
    }
    AutocompleteComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    AutocompleteComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    AutocompleteComponent.prototype.registerOnTouched = function (fn) {
        this.onBlur = fn;
    };
    AutocompleteComponent.prototype.setDisabledState = function (isDisabled) {
        this.isDisabled = isDisabled;
    };
    AutocompleteComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.config.results.subscribe(function (d) {
            _this.results = __spread(d);
        });
    };
    AutocompleteComponent.prototype.change = function ($event) {
        this.onChange(this.value);
    };
    AutocompleteComponent.prototype.search = function (event) {
        this.config.onSearch(event.query);
    };
    return AutocompleteComponent;
}());
AutocompleteComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'b-autocomplete',
                template: "<div class=\"form-group\">\n    <label>{{config?.label}}</label>\n    <p-autoComplete [(ngModel)]=\"value\" [suggestions]=\"results\" (completeMethod)=\"search($event)\" [multiple]=\"config.isMultiple\"\n    (onSelect)=\"change($event)\" (onUnselect)=\"change($event)\"></p-autoComplete>\n</div>",
                styles: [""],
                providers: [EXPANDED_INPUT_VALUE_ACCESSOR$5],
            },] },
];
AutocompleteComponent.ctorParameters = function () { return []; };
AutocompleteComponent.propDecorators = {
    "config": [{ type: core.Input },],
};
var EXPANDED_INPUT_VALUE_ACCESSOR$6 = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return DateComponent; }),
    multi: true,
};
var DateComponent = /** @class */ (function () {
    function DateComponent() {
        this.isDisabled = false;
    }
    DateComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    DateComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    DateComponent.prototype.registerOnTouched = function (fn) {
        this.onBlur = fn;
    };
    DateComponent.prototype.setDisabledState = function (isDisabled) {
        this.isDisabled = isDisabled;
    };
    DateComponent.prototype.ngOnInit = function () {
    };
    DateComponent.prototype.onSelect = function ($event) {
        this.onChange(this.value);
    };
    return DateComponent;
}());
DateComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'b-date',
                template: "<div class=\"form-group\">\n    <label>{{config?.label}}</label>\n    <p-calendar [(ngModel)]=\"value\"  (onBlur)=\"onBlur\" (onSelect)=\"onSelect($event)\"></p-calendar>\n</div>\n\n<!-- dateFormat=\"config.dateFormat\"\nd - day of month (no leading zero)\ndd - day of month (two digit)\no - day of the year (no leading zeros)\noo - day of the year (three digit)\nD - day name short\nDD - day name long\nm - month of year (no leading zero)\nmm - month of year (two digit)\nM - month name short\nMM - month name long\ny - year (two digit)\nyy - year (four digit)\n@ - Unix timestamp (ms since 01/01/1970)\n! - Windows ticks (100ns since 01/01/0001)\n'...' - literal text\n'' - single quote\nanything else - literal text \n-->",
                styles: [""],
                providers: [EXPANDED_INPUT_VALUE_ACCESSOR$6],
            },] },
];
DateComponent.ctorParameters = function () { return []; };
DateComponent.propDecorators = {
    "config": [{ type: core.Input },],
};
var BlenderUiModule = /** @class */ (function () {
    function BlenderUiModule() {
    }
    return BlenderUiModule;
}());
BlenderUiModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                    forms.FormsModule,
                    forms.ReactiveFormsModule,
                    inputtext.InputTextModule,
                    dropdown.DropdownModule,
                    checkbox.CheckboxModule,
                    radiobutton.RadioButtonModule,
                    inputtextarea.InputTextareaModule,
                    autocomplete.AutoCompleteModule,
                    calendar.CalendarModule,
                    animations.BrowserAnimationsModule
                ],
                declarations: [InputComponent, DropdownComponent, CheckboxComponent, RadiobuttonComponent, TextareaComponent, AutocompleteComponent, DateComponent],
                exports: [InputComponent, DropdownComponent, CheckboxComponent, RadiobuttonComponent, TextareaComponent, AutocompleteComponent, DateComponent]
            },] },
];

exports.BlenderUiModule = BlenderUiModule;
exports.ɵl = AutocompleteComponent;
exports.ɵk = EXPANDED_INPUT_VALUE_ACCESSOR$5;
exports.ɵf = CheckboxComponent;
exports.ɵe = EXPANDED_INPUT_VALUE_ACCESSOR$2;
exports.ɵn = DateComponent;
exports.ɵm = EXPANDED_INPUT_VALUE_ACCESSOR$6;
exports.ɵd = DropdownComponent;
exports.ɵc = EXPANDED_INPUT_VALUE_ACCESSOR$1;
exports.ɵa = EXPANDED_INPUT_VALUE_ACCESSOR;
exports.ɵb = InputComponent;
exports.ɵg = EXPANDED_INPUT_VALUE_ACCESSOR$3;
exports.ɵh = RadiobuttonComponent;
exports.ɵi = EXPANDED_INPUT_VALUE_ACCESSOR$4;
exports.ɵj = TextareaComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=blender-ui.umd.js.map
